Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 681652 - media-sound/alsa-utils-1.1.8: tests fail
Summary: media-sound/alsa-utils-1.1.8: tests fail
Status: RESOLVED FIXED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Current packages (show other bugs)
Hardware: All Linux
: Normal normal (vote)
Assignee: Gentoo Sound Team
URL: https://github.com/alsa-project/alsa-...
Whiteboard:
Keywords:
Depends on:
Blocks: 681368
  Show dependency tree
 
Reported: 2019-03-24 12:26 UTC by Rolf Eike Beer
Modified: 2019-09-14 01:28 UTC (History)
3 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
build.log (media-sound_alsa-utils-1.1.8_use_apqs8,73.21 KB, text/plain)
2019-03-24 12:26 UTC, Rolf Eike Beer
Details
build.log (ppc64) (alsa-utils-1.1.8:20190327-194351.log,43.95 KB, text/plain)
2019-03-27 22:43 UTC, ernsteiswuerfel
Details
build.log x86 (build.log,53.53 KB, text/plain)
2019-04-24 11:05 UTC, Thomas Deutschmann
Details
emerge --info (amd64, passes) (emerge.info.txt,16.64 KB, text/plain)
2019-04-24 13:40 UTC, Samuel Holland
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Rolf Eike Beer 2019-03-24 12:26:40 UTC
Created attachment 570596 [details]
build.log

Portage 2.3.62 (python 2.7.15-final-0, default/linux/sparc/17.0, gcc-8.2.0, glibc-2.28-r5, 4.16.8 sparc64)
=================================================================
System uname: Linux-4.16.8-sparc64-sun4v-with-gentoo-2.4.1
KiB Mem:    33133328 total,   7312208 free
KiB Swap:          0 total,         0 free
Timestamp of repository gentoo: Sun, 24 Mar 2019 01:15:01 +0000
sh bash 4.4_p23
ld GNU ld (Gentoo 2.30 p5) 2.30.0
distcc 3.3.2 sparc-unknown-linux-gnu [disabled]
ccache version 3.3.4 [disabled]
app-shells/bash:          4.4_p23::gentoo
dev-lang/perl:            5.26.2::gentoo
dev-lang/python:          2.7.15::gentoo, 3.5.5::gentoo, 3.6.5::gentoo
dev-util/ccache:          3.3.4-r1::gentoo
dev-util/cmake:           3.9.6::gentoo
sys-apps/baselayout:      2.4.1-r2::gentoo
sys-apps/openrc:          0.38.3-r1::gentoo
sys-apps/sandbox:         2.13::gentoo
sys-devel/autoconf:       2.13-r1::gentoo, 2.69-r4::gentoo
sys-devel/automake:       1.11.6-r3::gentoo, 1.16.1-r1::gentoo
sys-devel/binutils:       2.30-r4::gentoo
sys-devel/gcc:            8.2.0-r6::gentoo
sys-devel/gcc-config:     2.0::gentoo
sys-devel/libtool:        2.4.6-r3::gentoo
sys-devel/make:           4.2.1-r4::gentoo
sys-kernel/linux-headers: 4.14-r1::gentoo (virtual/os-headers)
sys-libs/glibc:           2.28-r5::gentoo
Repositories:

gentoo
    location: /usr/portage
    sync-type: git
    sync-uri: https://anongit.gentoo.org/git/repo/sync/gentoo.git
    priority: -1000
    sync-git-verify-commit-signature: yes

ACCEPT_KEYWORDS="sparc"
ACCEPT_LICENSE="* -@EULA"
CBUILD="sparc-unknown-linux-gnu"
CFLAGS="-O2 -mcpu=niagara2 -pipe -Wcast-align"
CHOST="sparc-unknown-linux-gnu"
CONFIG_PROTECT="/etc /etc/stunnel/stunnel.conf /usr/share/gnupg/qualified.txt /var/qmail/alias /var/qmail/control /var/spool/torque /var/vpopmail/etc"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/dconf /etc/env.d /etc/fonts/fonts.conf /etc/gconf /etc/gentoo-release /etc/php/apache2-php5.6/ext-active/ /etc/php/apache2-php7.1/ext-active/ /etc/php/apache2-php7.2/ext-active/ /etc/php/cgi-php5.6/ext-active/ /etc/php/cgi-php7.1/ext-active/ /etc/php/cgi-php7.2/ext-active/ /etc/php/cli-php5.6/ext-active/ /etc/php/cli-php7.1/ext-active/ /etc/php/cli-php7.2/ext-active/ /etc/revdep-rebuild /etc/sandbox.d /etc/terminfo"
CXXFLAGS="-O2 -mcpu=niagara2 -pipe -Wcast-align"
DISTDIR="/usr/portage/distfiles"
ENV_UNSET="DBUS_SESSION_BUS_ADDRESS DISPLAY GOBIN PERL5LIB PERL5OPT PERLPREFIX PERL_CORE PERL_MB_OPT PERL_MM_OPT XAUTHORITY XDG_CACHE_HOME XDG_CONFIG_HOME XDG_DATA_HOME XDG_RUNTIME_DIR"
FCFLAGS=""
FEATURES="assume-digests binpkg-docompress binpkg-dostrip binpkg-logs config-protect-if-modified distlocks ebuild-locks fixlafiles ipc-sandbox merge-sync network-sandbox news parallel-fetch pid-sandbox preserve-libs protect-owned sandbox sfperms strict unknown-features-warn unmerge-logs unmerge-orphans userfetch userpriv usersandbox usersync xattr"
FFLAGS=""
GENTOO_MIRRORS="ftp://ftp.wh2.tu-dresden.de/pub/mirrors/gentoo ftp://ftp.join.uni-muenster.de/pub/linux/distributions/gentoo"
LANG="en_US.UTF-8"
LDFLAGS="-Wl,-O1 -Wl,--as-needed"
MAKEOPTS="-j20 -l40"
PKGDIR="/usr/portage/packages"
PORTAGE_CONFIGROOT="/"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --omit-dir-times --compress --force --whole-file --delete --stats --human-readable --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages --exclude=/.git"
PORTAGE_TMPDIR="/var/tmp"
USE="acl berkdb big-endian bzip2 cli crypt cxx dri fortran gdbm iconv ipv6 libtirpc ncurses nls nptl openmp pam pcre readline sparc ssl tcpd unicode xattr zlib" APACHE2_MODULES="authn_core authz_core socache_shmcb unixd actions alias auth_basic authn_alias authn_anon authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache cgi cgid dav dav_fs dav_lock deflate dir disk_cache env expires ext_filter file_cache filter headers include info log_config logio mem_cache mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias" CALLIGRA_FEATURES="karbon sheets words" COLLECTD_PLUGINS="df interface irq load memory rrdtool swap syslog" ELIBC="glibc" GPSD_PROTOCOLS="ashtech aivdm earthmate evermore fv18 garmin garmintxt gpsclock isync itrax mtk3301 nmea ntrip navcom oceanserver oldstyle oncore rtcm104v2 rtcm104v3 sirf skytraq superstar2 timing tsip tripmate tnt ublox ubx" INPUT_DEVICES="libinput keyboard mouse" KERNEL="linux" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LIBREOFFICE_EXTENSIONS="presenter-console presenter-minimizer" NETBEANS_MODULES="apisupport cnd groovy gsf harness ide identity j2ee java mobility nb php profiler soa visualweb webcommon websvccommon xml" OFFICE_IMPLEMENTATION="libreoffice" PHP_TARGETS="php5-6 php7-1" POSTGRES_TARGETS="postgres9_5 postgres10" PYTHON_SINGLE_TARGET="python3_6" PYTHON_TARGETS="python2_7 python3_6" RUBY_TARGETS="ruby24" USERLAND="GNU" VIDEO_CARDS="fbdev glint mga r128 radeon dummy v4l" XTABLES_ADDONS="quota2 psd pknock lscan length2 ipv4options ipset ipp2p iface geoip fuzzy condition tee tarpit sysrq steal rawnat logmark ipmark dhcpmac delude chaos account"
Unset:  CC, CPPFLAGS, CTARGET, CXX, EMERGE_DEFAULT_OPTS, INSTALL_MASK, LC_ALL, LINGUAS, PORTAGE_BINHOST, PORTAGE_BUNZIP2_COMMAND, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, PORTAGE_RSYNC_EXTRA_OPTS
Comment 1 Sergei Trofimovich gentoo-dev 2019-03-25 21:44:16 UTC
Looks like the failure is:

make[3]: Entering directory '/var/tmp/portage/media-sound/alsa-utils-1.1.8/work/alsa-utils-1.1.8/axfer/test'
container-test: container-test.c:53: test_builder: Assertion `err == 0' failed.
/bin/sh: line 5:   223 Aborted                 ${dir}$tst
FAIL: container-test
Invalid argument
FAIL: mapper-test
===================
2 of 2 tests failed

Which is:

    err = container_context_pre_process(cntr, &sample, &channels, &rate,
        &max_frame_count);
    assert(err == 0);

For me the tests pass on amd64, but fail on ppc64 and fail on ppc:
container-test: ../container.c:333: container_context_pre_process: Assertion `*samples_per_frame > 0' failed.

The error is slightly different but perhaps both experience an endianness bug.
Comment 2 ernsteiswuerfel 2019-03-27 22:43:11 UTC
Created attachment 570990 [details]
build.log (ppc64)

container-test fails on ppc64 too.
Comment 3 Samuel Holland 2019-04-21 00:31:29 UTC
I've sent a patch upstream at https://github.com/alsa-project/alsa-utils/pull/15
Comment 4 Thomas Deutschmann gentoo-dev Security 2019-04-24 11:05:50 UTC
Created attachment 573944 [details]
build.log x86

Same on x86:

> make  check-TESTS
> make[3]: Entering directory '/var/tmp/portage/media-sound/alsa-utils-1.1.8/work/alsa-utils-1.1.8/axfer/test'
> container-test: container-test.c:53: test_builder: Assertion `err == 0' failed.
> /bin/sh: line 5:   225 Aborted                 (core dumped) ${dir}$tst
> FAIL: container-test
> Invalid argument
> FAIL: mapper-test
> ===================
> 2 of 2 tests failed
> ===================

Backtrace:

> GNU gdb (Gentoo 8.1 p1) 8.1
> Copyright (C) 2018 Free Software Foundation, Inc.
> License GPLv3+: GNU GPL version 3 or later <http://gnu.org/licenses/gpl.html>
> This is free software: you are free to change and redistribute it.
> There is NO WARRANTY, to the extent permitted by law.  Type "show copying"
> and "show warranty" for details.
> This GDB was configured as "i686-pc-linux-gnu".
> Type "show configuration" for configuration details.
> For bug reporting instructions, please see:
> <https://bugs.gentoo.org/>.
> Find the GDB manual and other documentation resources online at:
> <http://www.gnu.org/software/gdb/documentation/>.
> For help, type "help".
> Type "apropos word" to search for commands related to "word"...
> Reading symbols from /var/tmp/portage/media-sound/alsa-utils-1.1.8/work/alsa-utils-1.1.8/axfer/test/container-test...done.
> [New LWP 225]
> [Thread debugging using libthread_db enabled]
> Using host libthread_db library "/lib/libthread_db.so.1".
> Core was generated by `./container-test'.
> Program terminated with signal SIGABRT, Aborted.
> #0  0xb7fb8bd5 in __kernel_vsyscall ()
> (gdb) bt
> #0  0xb7fb8bd5 in __kernel_vsyscall ()
> #1  0xb7cd3bba in __libc_signal_restore_set (set=0xbfef4f2c) at ../sysdeps/unix/sysv/linux/internal-signals.h:84
> #2  __GI_raise (sig=6) at ../sysdeps/unix/sysv/linux/raise.c:48
> #3  0xb7cbc2b5 in __GI_abort () at abort.c:79
> #4  0xb7cbc1be in __assert_fail_base (fmt=0xb7e3a34c "%s%s%s:%u: %s%sAssertion `%s' failed.\n%n", assertion=assertion@entry=0x413633 "err == 0",
>     file=file@entry=0x413622 "container-test.c", line=line@entry=53, function=function@entry=0x41376c <__PRETTY_FUNCTION__.9283> "test_builder")
>     at assert.c:92
> #5  0xb7ccb1b4 in __GI___assert_fail (assertion=0x413633 "err == 0", file=0x413622 "container-test.c", line=53,
>     function=0x41376c <__PRETTY_FUNCTION__.9283> "test_builder") at assert.c:101
> #6  0x004126ee in test_builder (name=<optimized out>, access=<optimized out>, verbose=<optimized out>, frame_count=<optimized out>,
>     frame_buffer=<optimized out>, frames_per_second=<optimized out>, samples_per_frame=<optimized out>, sample_format=<optimized out>,
>     format=<optimized out>, cntr=<optimized out>) at container-test.c:161
> #7  callback (gen=0xbfef539c, access=SND_PCM_ACCESS_MMAP_INTERLEAVED, sample_format=SND_PCM_FORMAT_U24_3LE, samples_per_frame=1, frame_buffer=0x236af20,
>     frame_count=23) at container-test.c:151
> #8  0x00412207 in test_frame_count (samples_per_frame=1, sample_format=SND_PCM_FORMAT_U24_3LE, access=SND_PCM_ACCESS_MMAP_INTERLEAVED, gen=0xbfef539c)
>     at generator.c:188
> #9  test_samples_per_frame (sample_format=SND_PCM_FORMAT_U24_3LE, access=SND_PCM_ACCESS_MMAP_INTERLEAVED, gen=0xbfef539c) at generator.c:208
> #10 test_sample_format (access=SND_PCM_ACCESS_MMAP_INTERLEAVED, gen=0xbfef539c) at generator.c:226
> #11 test_access (gen=0xbfef539c) at generator.c:243
> #12 generator_context_run (gen=0xbfef539c, cb=0x4122d5 <callback>) at generator.c:253
> #13 0x0040f390 in main (argc=1, argv=0xbfef5484) at container-test.c:284
> (gdb)

However I did apply https://github.com/alsa-project/alsa-utils/pull/15 so this doesn't look fixed.


Portage 2.3.62 (python 3.6.5-final-0, default/linux/x86/17.0, gcc-8.2.0, glibc-2.28-r6, 4.19.27-gentoo-r1 i686)
=================================================================
System uname: Linux-4.19.27-gentoo-r1-i686-Intel-R-_Core-TM-_i7-3770K_CPU_@_3.50GHz-with-gentoo-2.6
KiB Mem:     3106596 total,   1178496 free
KiB Swap:     488276 total,    488276 free
Timestamp of repository gentoo: Wed, 24 Apr 2019 05:04:26 +0000
Head commit of repository gentoo: ff35258e6e0168563dd0f08e3c6f1f42ea5a1374

sh bash 4.4_p23-r1
ld GNU ld (Gentoo 2.31.1 p5) 2.31.1
app-shells/bash:          4.4_p23-r1::gentoo
dev-lang/perl:            5.26.2::gentoo
dev-lang/python:          2.7.15::gentoo, 3.6.5::gentoo
dev-util/cmake:           3.9.6::gentoo
sys-apps/baselayout:      2.6-r1::gentoo
sys-apps/openrc:          0.38.3-r1::gentoo
sys-apps/sandbox:         2.13::gentoo
sys-devel/autoconf:       2.13-r1::gentoo, 2.69-r4::gentoo
sys-devel/automake:       1.16.1-r1::gentoo
sys-devel/binutils:       2.31.1-r4::gentoo
sys-devel/gcc:            8.2.0-r6::gentoo
sys-devel/gcc-config:     2.0::gentoo
sys-devel/libtool:        2.4.6-r3::gentoo
sys-devel/make:           4.2.1-r4::gentoo
sys-kernel/linux-headers: 4.14-r1::gentoo (virtual/os-headers)
sys-libs/glibc:           2.28-r6::gentoo
Repositories:

gentoo
    location: /usr/portage
    sync-type: git
    sync-uri: https://github.com/gentoo-mirror/gentoo.git
    priority: -1000

ABI="x86"
ABI_X86="32"
ACCEPT_KEYWORDS="x86"
ACCEPT_LICENSE="* -@EULA"
ACCEPT_PROPERTIES="*"
ACCEPT_RESTRICT="*"
ARCH="x86"
BROOT=""
CBUILD="i686-pc-linux-gnu"
CFLAGS="-O2 -pipe -march=pentium4m -mtune=pentium4m -Wno-error=jump-misses-init -Wno-error=sign-compare"
CHOST="i686-pc-linux-gnu"
CHOST_x86="i686-pc-linux-gnu"
COLLISION_IGNORE="/lib/modules/*"
CONFIG_PROTECT="/etc /usr/share/config /usr/share/gnupg/qualified.txt"
CPU_FLAGS_X86="mmx mmxext sse sse2"
CXXFLAGS="-O2 -pipe -march=pentium4m -mtune=pentium4m -Wno-error=jump-misses-init -Wno-error=sign-compare"
DEFAULT_ABI="x86"
EDITOR="/usr/bin/mcedit"
ELIBC="glibc"
ENV_UNSET="DBUS_SESSION_BUS_ADDRESS DISPLAY GOBIN PERL5LIB PERL5OPT PERLPREFIX PERL_CORE PERL_MB_OPT PERL_MM_OPT XAUTHORITY XDG_CACHE_HOME XDG_CONFIG_HOME XDG_DATA_HOME XDG_RUNTIME_DIR"
EPREFIX=""
EROOT="/"
ESYSROOT="/"
FCFLAGS="-O2 -march=i686 -pipe"
FEATURES="assume-digests binpkg-docompress binpkg-dostrip binpkg-logs cgroup config-protect-if-modified distlocks downgrade-backup ebuild-locks fixlafiles ipc-sandbox merge-sync multilib-strict network-sandbox news parallel-fetch pid-sandbox preserve-libs protect-owned sandbox sfperms strict unknown-features-warn unmerge-logs unmerge-orphans userfetch userpriv usersandbox usersync xattr"
FFLAGS="-O2 -march=i686 -pipe"
GCC_SPECS=""
GRUB_PLATFORMS="efi-32 pc"
GSETTINGS_BACKEND="dconf"
HOME="/root"
INFOPATH="/usr/share/gcc-data/i686-pc-linux-gnu/8.2.0/info:/usr/share/binutils-data/i686-pc-linux-gnu/2.31.1/info:/usr/share/info"
INPUT_DEVICES="libinput keyboard mouse"
IUSE_IMPLICIT="abi_x86_32 prefix prefix-guest prefix-stack"
KERNEL="linux"
L10N="en en-US de de-DE"
LANG="en_US.UTF-8"
LC_ALL="en_US.UTF-8"
LC_MESSAGES="C"
LC_PAPER="de_DE.UTF-8"
LDFLAGS="-Wl,-O1 -Wl,--as-needed"
LIBDIR_x86="lib"
LINGUAS="en de"
LOGNAME="root"
MAIL="/var/mail/root"
MAKEOPTS="--jobs 5 --load-average 7.95"
MULTILIB_ABIS="x86"
NETBEANS_MODULES="apisupport cnd groovy gsf harness ide identity j2ee java mobility nb php profiler soa visualweb webcommon websvccommon xml"
NOCOLOR="true"
OFFICE_IMPLEMENTATION="libreoffice"
OPENCL_PROFILE="ocl-icd"
OPENGL_PROFILE="xorg-x11"
PAGER="/usr/bin/less"
PATH="/usr/lib/llvm/6/bin:/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/opt/bin"
PHP_TARGETS="php5-6 php7-1 php7-2 php7-3"
POSTGRES_TARGETS="postgres9_5 postgres10"
PWD="/root"
PYTHONDONTWRITEBYTECODE="1"
PYTHON_SINGLE_TARGET="python3_6"
PYTHON_TARGETS="python2_7 python3_6"
QT_GRAPHICSSYSTEM="raster"
ROOT="/"
ROOTPATH="/usr/lib/llvm/6/bin:/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/opt/bin"
RUBY_TARGETS="ruby24"
SHELL="/bin/bash"
SHLVL="2"
SSH_TTY="/dev/pts/0"
SYSROOT="/"
TERM="tmux-256color"
TMUX="/tmp//tmux-0/default,4190,0"
TMUX_PANE="%3"
TWISTED_DISABLE_WRITING_OF_PLUGIN_CACHE="1"
USER="root"
USERLAND="GNU"
VIDEO_CARDS="vmware"
XDG_CONFIG_DIRS="/etc/xdg"
XDG_DATA_DIRS="/usr/local/share:/usr/share"
Comment 5 Rolf Eike Beer 2019-04-24 11:26:09 UTC
Did it pass without the patch?
Comment 6 Thomas Deutschmann gentoo-dev Security 2019-04-24 11:37:53 UTC
No, it did not pass without, that's why gave the patch a try at all.
Comment 7 Samuel Holland 2019-04-24 13:40:02 UTC
Created attachment 573962 [details]
emerge --info (amd64, passes)

The patch I linked is only for big-endian machines. It fixes the tests for me on ppc64.

The tests passed for me on amd64 without any patching. If they are failing on a little-endian machine, there's another bug somewhere (or something wrong with your setup).

I'm attaching the `emerge --info` from my amd64 box that didn't need patching.

I do have a patch applied for the exp10 definition (see https://github.com/alsa-project/alsa-utils/commit/116488e5f2f1b897084bd151381ee254e1cc177d), but that doesn't affect the axfer code being tested.
Comment 8 Rolf Eike Beer 2019-04-24 14:39:10 UTC
For me (with the patch) it fails on sparc with:

gawk: cmd. line:1: (FILENAME=- FNR=1) fatal: redirection not allowed in sandbox mode
Comment 9 Rolf Eike Beer 2019-06-23 11:20:34 UTC
Failure is the same with 1.1.9 on sparc for me.
Comment 10 Pacho Ramos gentoo-dev 2019-06-30 12:09:21 UTC
can you open a new bug report to upstream with the pending to fix failures after applying the patches?

Thanks
Comment 11 Rolf Eike Beer 2019-07-27 14:50:17 UTC
Reported upstream, url updated.
Comment 12 Rolf Eike Beer 2019-07-28 07:28:05 UTC
Looks like at least one remaining error affects 32 bit platforms because of bad shifts. I'll wait for upstream and report back.
Comment 13 Rolf Eike Beer 2019-07-31 16:40:01 UTC
The remaining test failures are just bugs in the test code: it does shifts outside of the 32bit range of the variables. Fix is merged upstream.
Comment 14 Larry the Git Cow gentoo-dev 2019-09-14 01:28:15 UTC
The bug has been closed via the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=9678a57328cc2064f340bdcbd69bf4bf01554e29

commit 9678a57328cc2064f340bdcbd69bf4bf01554e29
Author:     Matt Turner <mattst88@gentoo.org>
AuthorDate: 2019-09-14 01:25:24 +0000
Commit:     Matt Turner <mattst88@gentoo.org>
CommitDate: 2019-09-14 01:25:27 +0000

    media-sound/alsa-utils: Add patch to fix tests
    
    Closes: https://bugs.gentoo.org/681652
    Signed-off-by: Matt Turner <mattst88@gentoo.org>

 media-sound/alsa-utils/alsa-utils-1.1.9.ebuild     |   1 +
 ...fix-invalid-comparison-of-64-bit-storage-.patch | 249 +++++++++++++++++++++
 2 files changed, 250 insertions(+)